
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
typedef struct bb_whileExtractData S_bb_whileExtractData;
typedef struct fileItemBits S_fileItemBits;
typedef struct __jmp_buf_tag S___jmp_buf_tag;
typedef struct timeval S_timeval;
extern char * taskRegimesName[];
typedef struct _IO_jump_t S__IO_jump_t;
typedef struct editorUndo S_editorUndo;
typedef struct cachePoint S_cachePoint;
typedef struct zipArchiveDir S_zipArchiveDir;
typedef struct pushAllInBetweenData S_pushAllInBetweenData;
typedef struct cline S_cline;
extern char * editorUndoOperationsName[];
typedef struct currentlyParsedCl S_currentlyParsedCl;
typedef struct editorBufferTab S_editorBufferTab;
typedef struct idTab S_idTab;
typedef struct completions S_completions;
typedef struct nestedSpec S_nestedSpec;
typedef struct tpCheckMoveClassData S_tpCheckMoveClassData;
extern char * usagesName[];
typedef struct idIdent S_idIdent;
typedef struct bb_typeModifiersListPositionLstPair S_bb_typeModifiersListPositionLstPair;
typedef struct fileItemList S_fileItemList;
typedef struct symbolRefItem S_symbolRefItem;
typedef struct stringList S_stringList;
typedef struct intStringTab S_intStringTab;
typedef union editorUndoUnion U_editorUndoUnion;
typedef struct unsPositionPair S_unsPositionPair;
typedef struct sigevent S_sigevent;
extern char * trivialPreChecksName[];
typedef struct __gconv_info S___gconv_info;
typedef struct macroArgTabElem S_macroArgTabElem;
typedef struct z_stream_s S_z_stream_s;
typedef struct tokenNameIni S_tokenNameIni;
typedef struct methodTypeModif S_methodTypeModif;
typedef struct cctNode S_cctNode;
typedef struct editorRegionList S_editorRegionList;
typedef struct symbolPositionPair S_symbolPositionPair;
typedef struct __pthread_attr_s S___pthread_attr_s;
typedef struct lexInput S_lexInput;
typedef struct __gconv_step_data S___gconv_step_data;
typedef struct internal_state S_internal_state;
typedef struct referencesChangeData S_referencesChangeData;
extern char * fileEncodingsName[];
typedef struct _pthread_descr_struct S__pthread_descr_struct;
typedef struct htmlRefList S_htmlRefList;
typedef struct symbol S_symbol;
typedef struct random_data S_random_data;
extern char * extractModesName[];
typedef struct usageBits S_usageBits;
typedef struct olSymbolFoundInformation S_olSymbolFoundInformation;
typedef struct bb_unsPositionPair S_bb_unsPositionPair;
typedef struct bb_int S_bb_int;
typedef struct refTab S_refTab;
typedef struct completionFqtMapInfo S_completionFqtMapInfo;
typedef struct completionSymFunInfo S_completionSymFunInfo;
typedef struct htmlData S_htmlData;
typedef struct funTypeModif S_funTypeModif;
extern char * copyFlagName[];
typedef struct __sched_param S___sched_param;
extern char * syntaxPassParsedImportantPositionName[];
typedef struct stringAddrList S_stringAddrList;
typedef struct editorMarkerList S_editorMarkerList;
typedef struct whileExtractData S_whileExtractData;
typedef struct symStructSpecific S_symStructSpecific;
typedef struct bb_nestedConstrTokenType S_bb_nestedConstrTokenType;
typedef struct extRecFindStr S_extRecFindStr;
typedef struct olCompletion S_olCompletion;
typedef struct nestedConstrTokenType S_nestedConstrTokenType;
typedef struct typeModificationsInit S_typeModificationsInit;
typedef struct olcxReferencesStack S_olcxReferencesStack;
typedef struct editorBufferAllocationData S_editorBufferAllocationData;
typedef struct _IO_FILE S__IO_FILE;
typedef struct topBlock S_topBlock;
typedef struct timespec S_timespec;
typedef struct counters S_counters;
typedef struct symTab S_symTab;
typedef struct __gconv_trans_data S___gconv_trans_data;
typedef struct bb_unsigned S_bb_unsigned;
typedef struct disabledList S_disabledList;
typedef struct javaTypePCTIConvertIni S_javaTypePCTIConvertIni;
typedef struct olcxReferences S_olcxReferences;
extern char * olcxOptionsName[];
extern char * refCategoriesName[];
typedef struct setGetEnv S_setGetEnv;
typedef struct optionsList S_optionsList;
typedef struct lexBuf S_lexBuf;
extern char * memoriesName[];
typedef struct bb_symbolPositionLstPair S_bb_symbolPositionLstPair;
typedef struct completionFunTab S_completionFunTab;
typedef struct symbolRefItemBits S_symbolRefItemBits;
typedef struct javaFqtTab S_javaFqtTab;
typedef struct typeModifiersListPositionLstPair S_typeModifiersListPositionLstPair;
typedef struct yyGlobalState S_yyGlobalState;
typedef struct _IO_marker S__IO_marker;
extern char * editorsName[];
typedef struct fileItem S_fileItem;
extern char * storagesName[];
typedef struct mallinfo S_mallinfo;
typedef struct bb_idIdent S_bb_idIdent;
typedef struct positionLst S_positionLst;
typedef struct editorBuffer S_editorBuffer;
typedef struct editorBufferList S_editorBufferList;
typedef struct availableRefactoring S_availableRefactoring;
typedef struct cppIfStack S_cppIfStack;
typedef struct bb_symbolList S_bb_symbolList;
typedef struct recFindStr S_recFindStr;
extern char * updateModifiersName[];
typedef struct drand48_data S_drand48_data;
typedef struct olSymbolsMenu S_olSymbolsMenu;
extern char * addImportsDefaultName[];
typedef struct freeTrail S_freeTrail;
typedef struct typeModifiers S_typeModifiers;
typedef struct charBuf S_charBuf;
typedef struct currentlyParsedStatics S_currentlyParsedStatics;
typedef struct typeCharCodeIni S_typeCharCodeIni;
typedef struct editorMarker S_editorMarker;
extern char * javaPCTIndexName[];
typedef struct editorMemoryBlock S_editorMemoryBlock;
typedef struct memory S_memory;
typedef struct symbolBits S_symbolBits;
typedef struct chReference S_chReference;
typedef struct editorUndoStrReplace S_editorUndoStrReplace;
typedef struct completionSymInfo S_completionSymInfo;
typedef struct bb_position S_bb_position;
typedef struct symbolRefItemList S_symbolRefItemList;
typedef struct tm S_tm;
extern char * typesName[];
typedef struct stat S_stat;
typedef struct htmlLocalListms S_htmlLocalListms;
typedef struct editorRegion S_editorRegion;
typedef struct jslClassStat S_jslClassStat;
typedef struct bb_positionLst S_bb_positionLst;
typedef struct editorUndoRenameBuff S_editorUndoRenameBuff;
typedef struct javaStat S_javaStat;
typedef struct zipFileTabItem S_zipFileTabItem;
typedef struct cxScanFileFunctionLink S_cxScanFileFunctionLink;
extern char * __codecvt_resultName[];
typedef struct macroBody S_macroBody;
typedef struct jslTypeTab S_jslTypeTab;
typedef struct tpCheckSpecialReferencesData S_tpCheckSpecialReferencesData;
extern char * refsFilterLevelsName[];
typedef struct symbolList S_symbolList;
typedef struct htmlCutPathesOpts S_htmlCutPathesOpts;
typedef struct bb_freeTrail S_bb_freeTrail;
typedef struct typeModifiersList S_typeModifiersList;
typedef struct symbolPositionLstPair S_symbolPositionLstPair;
typedef struct position S_position;
typedef union typeModifUnion U_typeModifUnion;
typedef struct idIdentList S_idIdentList;
typedef struct exprTokenType S_exprTokenType;
extern char * sFunResultName[];
typedef struct classTreeData S_classTreeData;
extern char * menuFilterLevelsName[];
extern char * miscellaneousName[];
typedef struct fileStat S_fileStat;
typedef struct caching S_caching;
typedef struct fileDesc S_fileDesc;
typedef struct bb_exprTokenType S_bb_exprTokenType;
extern char * refScopesName[];
typedef struct userOlcx S_userOlcx;
extern char * commentMovingsName[];
typedef struct __gconv_loaded_object S___gconv_loaded_object;
typedef struct bb_symbolPositionPair S_bb_symbolPositionPair;
typedef struct bb_symbol S_bb_symbol;
typedef struct options S_options;
typedef struct _pthread_fastlock S__pthread_fastlock;
typedef struct bb_idIdentList S_bb_idIdentList;
extern char * inputTypeName[];
typedef union defUnion U_defUnion;
typedef struct __gconv_step S___gconv_step;
typedef struct bb_intPair S_bb_intPair;
typedef struct intlist S_intlist;
typedef struct jslSymbolList S_jslSymbolList;
typedef struct bb_typeModifiers S_bb_typeModifiers;
typedef struct reference S_reference;
typedef struct editorUndoMoveBlock S_editorUndoMoveBlock;
typedef struct bb_typeModifiersList S_bb_typeModifiersList;
typedef struct programGraphNode S_programGraphNode;
typedef struct editorBufferBits S_editorBufferBits;
typedef struct itimerspec S_itimerspec;
typedef struct intPair S_intPair;
typedef struct jslStat S_jslStat;
typedef struct _IO_FILE_plus S__IO_FILE_plus;
#include "head2.h"
#include "zlib.h"
#include "lexmac.h"
typedef unsigned char uchar;
enum miscellaneous {
        DEFAULT_VALUE,
        TYPE_ADD_YES,
        TYPE_ADD_NO,
        ADD_YES,
        ADD_NO,
        CLASS_TO_TYPE,
        CLASS_TO_EXPR,
        CLASS_TO_METHOD,
        CLASS_TO_ANY,
        ACC_CHECK_YES,
        ACC_CHECK_NO,
        VISIB_CHECK_YES,
        VISIB_CHECK_NO,
        CUT_OVERRIDEN_YES,
        CUT_OVERRIDEN_NO,
        CX_FILE_ITEM_GEN,
        NO_CX_FILE_ITEM_GEN,
        CX_GENERATE_OUTPUT,
        CX_JUST_READ,
        CX_HTML_FIRST_PASS,
        CX_HTML_SECOND_PASS,
        CX_MENU_CREATION,
        CX_BY_PASS,
        HTML_GEN,
        HTML_NO_GEN,
        MEM_ALLOC_ON_SM,
        MEM_ALLOC_ON_PP,
        MEM_NO_ALLOC,
        MESS_REFERENCE_OVERFLOW,
        MESS_FILE_ABORT,
        MESS_NONE,
        INFILES_ENABLED,
        INFILES_DISABLED,
        BEFORE_BLOCK,
        INSIDE_BLOCK,
        AFTER_BLOCK,
        EXTRACT_LOCAL_VAR,
        EXTRACT_VALUE_ARGUMENT,
        EXTRACT_LOCAL_OUT_ARGUMENT,
        EXTRACT_OUT_ARGUMENT,
        EXTRACT_IN_OUT_ARGUMENT,
        EXTRACT_ADDRESS_ARGUMENT,
        EXTRACT_RESULT_VALUE,
        EXTRACT_IN_RESULT_VALUE,
        EXTRACT_LOCAL_RESULT_VALUE,
        EXTRACT_NONE,
        EXTRACT_ERROR,
        INVOCATION_XREF,
        INVOCATION_SETUP,
        INVOCATION_SPELLER,
        SETUP_EDITOR_EMACS,
        SETUP_EDITOR_XEMACS,
        SETUP_EDITOR_VEDIT3,
        SETUP_SHELL_SH,
        SETUP_SHELL_CSH,
        SETUP_SHELL_BASH,
        SETUP_SHELL_UNKNOWN,
        LOADING_SYMBOL,
        SEARCH_SYMBOL,
        FF_SCHEDULED_TO_PROCESS,
        FF_COMMAND_LINE_ENTERED,
        OL_LOOKING_2_PASS_MACRO_USAGE,
        SHORT_NAME,
        LONG_NAME,
        GEN_HTML,
        GEN_JAVA_DOC,
        ONLINE_ONLY,
        ALL_REFS,
        COUNT_ONLY,
        CUT_OUTERS,
        NO_OUTERS_CUT,
        VIRT_ITEM,
        SINGLE_VIRT_ITEM,
        FIRST_PASS,
        SECOND_PASS,
        DO_NOT_CHECK_IF_SELECTED,
        PUSH_AFTER_MENU,
        CHECK_NULL,
        RESULT_IS_CLASS_FILE,
        RESULT_IS_JAVA_FILE,
        RESULT_NO_FILE_FOUND,
        TRAILED_YES,
        TRAILED_NO,
        CPOS_FUNCTION_INNER,
        CPOS_ST,
        DIRECT_ONLY,
        SUPERCLASS_NESTED_TOO,
        DIFF_MISSING_REF,
        DIFF_UNEXPECTED_REF,
        CONSTRUCTOR_INVOCATION,
        REGULAR_METHOD,
        SUPER_METHOD_INVOCATION,
        RESOLVE_DIALOG_ALLWAYS,
        RESOLVE_DIALOG_NEVER,
        GLOBAL_ENV_ONLY,
        NO_ERROR_MESSAGE,
        ADD_CX_REFS,
        NO_CX_REFS,
        ORDER_PREPEND,
        ORDER_APPEND,
        MEMBER_CLASS,
        MEMBER_TYPE,
        GEN_VIRTUALS,
        GEN_NON_VIRTUALS,
        REQ_FIELD,
        REQ_METHOD,
        REQ_STATIC,
        REQ_NONSTATIC,
        REQ_SUPERCLASS,
        REQ_SUBCLASS,
        REQ_CLASS,
        REQ_PACKAGE,
        INSPECT_DEF,
        INSPECT_CLASS,
        DOTIFY_NAME,
        KEEP_SLASHES,
        LOAD_SUPER,
        DO_NOT_LOAD_SUPER,
        INPUT_DIRECT,
        INPUT_VIA_UNZIP,
        INPUT_VIA_EDITOR,
        FQT_COMPLETE_ALSO_ON_PACKAGE,
        ADD_MAYBE_THIS_REFERENCE,
        TSS_FULL_SEARCH,
        TSS_SEARCH_DEFS_ONLY,
        TSS_FULL_SEARCH_SHORT,
        TSS_SEARCH_DEFS_ONLY_SHORT,
        GEN_FULL_OUTPUT,
        GEN_PRECHECKS,
        GEN_NO_OUTPUT,
        CHECK_FOR_ADD_PARAM,
        CHECK_FOR_DEL_PARAM,
        GET_PRIMARY_START,
        GET_STATIC_PREFIX_START,
        APPLY_CHECKS,
        NO_CHECKS,
        CONTINUATION_ENABLED,
        CONTINUATION_DISABLED,
        NO_OVERWRITE_CHECK,
        CHECK_OVERWRITE,
        ALLOW_EDITOR_FILES,
        DO_NOT_ALLOW_EDITOR_FILES,
        DEEP_ONE,
        DEEP_ANY,
        DEAD_CODE_DETECTION,
        INTERACTIVE_YES,
        INTERACTIVE_NO,
        MARKER_IS_IN_CODE,
        MARKER_IS_IN_SLASH_COMMENT,
        MARKER_IS_IN_STAR_COMMENT,
        PROFILE_NOT_APPLICABLE,
        PROFILE_APPLICABLE,
        PROFILE_PARTIALLY_APPLICABLE,
        USELESS_FQT_REFS_ALLOWED,
        USELESS_FQT_REFS_DISALLOWED,
        PULLING_UP,
        PUSHING_DOWN,
};
enum fileEncodings {
        MULE_DEFAULT,
        MULE_EUROPEAN,
        MULE_EUC,
        MULE_SJIS,
        MULE_UTF,
        MULE_UTF_8,
        MULE_UTF_16,
        MULE_UTF_16LE,
        MULE_UTF_16BE,
};
enum commentMovings {
        CM_NO_COMMENT,
        CM_SINGLE_SLASHED,
        CM_SINGLE_STARED,
        CM_SINGLE_SLASHED_AND_STARED,
        CM_ALL_SLASHED,
        CM_ALL_STARED,
        CM_ALL_SLASHED_AND_STARED,
};
enum addImportsDefault {
        NID_IMPORT_ON_DEMAND,
        NID_SINGLE_TYPE_IMPORT,
        NID_KEPP_FQT_NAME,
};
enum {
        PD_ZERO,
        PD_SHALLOW,
        PD_DEEP,
        PD_DEEPEST,
};
enum {
        RC_ZERO,
        RC_CONTINUE,
        RC_IMPORT_SINGLE_TYPE,
        RC_IMPORT_ON_DEMAND,
};
enum {
  ERR_ST,
  ERR_CANT_OPEN,
  ERR_CANT_EXECUTE,
  ERR_NO_MEMORY,
  ERR_INTERNAL,
  ERR_INTERNAL_CHECK,
  ERR_CFG,
  ERR_LICENSE,
  ERR_BIN_LICENSE,
};
enum taskRegimes {
        RegimeUndefined,
        RegimeXref,
        RegimeEditServer,
        RegimeGenerate,
        RegimeHtmlGenerate,
        RegimeRefactory,
};
enum olcxOptions {
        OLO_COMPLETION,
        OLO_SEARCH,
        OLO_TAG_SEARCH,
        OLO_RENAME,
        OLO_ENCAPSULATE,
        OLO_ARG_MANIP,
        OLO_VIRTUAL2STATIC_PUSH,
        OLO_GET_AVAILABLE_REFACTORINGS,
        OLO_PUSH,
        OLO_PUSH_NAME,
        OLO_PUSH_SPECIAL_NAME,
        OLO_POP,
        OLO_POP_ONLY,
        OLO_PLUS,
        OLO_MINUS,
        OLO_GOTO_CURRENT,
        OLO_GET_CURRENT_REFNUM,
        OLO_GOTO_PARAM_NAME,
        OLO_GLOBAL_UNUSED,
        OLO_LOCAL_UNUSED,
        OLO_LIST,
        OLO_LIST_TOP,
        OLO_PUSH_ONLY,
        OLO_PUSH_AND_CALL_MACRO,
        OLO_PUSH_ALL_IN_METHOD,
        OLO_PUSH_FOR_LOCALM,
        OLO_GOTO,
        OLO_CGOTO,
        OLO_TAGGOTO,
        OLO_TAGSELECT,
        OLO_CBROWSE,
        OLO_REF_FILTER_SET,
        OLO_REF_FILTER_PLUS,
        OLO_REF_FILTER_MINUS,
        OLO_CSELECT,
        OLO_COMPLETION_BACK,
        OLO_COMPLETION_FORWARD,
        OLO_EXTRACT,
        OLO_CT_INSPECT_DEF,
        OLO_MENU_INSPECT_DEF,
        OLO_MENU_INSPECT_CLASS,
        OLO_MENU_SELECT,
        OLO_MENU_SELECT_ONLY,
        OLO_MENU_SELECT_ALL,
        OLO_MENU_SELECT_NONE,
        OLO_MENU_FILTER_SET,
        OLO_MENU_FILTER_PLUS,
        OLO_MENU_FILTER_MINUS,
        OLO_MENU_GO,
        OLO_CHECK_VERSION,
        OLO_RESET_REF_SUFFIX,
        OLO_TRIVIAL_PRECHECK,
        OLO_MM_PRE_CHECK,
        OLO_PP_PRE_CHECK,
        OLO_SAFETY_CHECK_INIT,
        OLO_SAFETY_CHECK1,
        OLO_SAFETY_CHECK2,
        OLO_INTERSECTION,
        OLO_REMOVE_WIN,
        OLO_GOTO_DEF,
        OLO_GOTO_CALLER,
        OLO_SHOW_TOP,
        OLO_SHOW_TOP_APPL_CLASS,
        OLO_SHOW_TOP_TYPE,
        OLO_SHOW_CLASS_TREE,
        OLO_TOP_SYMBOL_RES,
        OLO_ACTIVE_PROJECT,
        OLO_JAVA_HOME,
        OLO_REPUSH,
        OLO_CLASS_TREE,
        OLO_USELESS_LONG_NAME,
        OLO_USELESS_LONG_NAME_IN_CLASS,
        OLO_MAYBE_THIS,
        OLO_NOT_FQT_REFS,
        OLO_NOT_FQT_REFS_IN_CLASS,
        OLO_GET_ENV_VALUE,
        OLO_SET_MOVE_TARGET,
        OLO_SET_MOVE_CLASS_TARGET,
        OLO_SET_MOVE_METHOD_TARGET,
        OLO_GET_CURRENT_CLASS,
        OLO_GET_CURRENT_SUPER_CLASS,
        OLO_GET_METHOD_COORD,
        OLO_GET_CLASS_COORD,
        OLO_GET_SYMBOL_TYPE,
        OLO_TAG_SEARCH_FORWARD,
        OLO_TAG_SEARCH_BACK,
        OLO_PUSH_ENCAPSULATE_SAFETY_CHECK,
        OLO_ENCAPSULATE_SAFETY_CHECK,
        OLO_SYNTAX_PASS_ONLY,
        OLO_GET_PRIMARY_START,
        OLO_GET_PARAM_COORDINATES,
        OLO_ABOUT,
};
enum editorUndoOperations {
        UNDO_REPLACE_STRING,
        UNDO_RENAME_BUFFER,
        UNDO_MOVE_BLOCK,
};
enum trivialPreChecks {
        TPC_NONE,
        TPC_MOVE_FIELD,
        TPC_RENAME_PACKAGE,
        TPC_RENAME_CLASS,
        TPC_MOVE_CLASS,
        TPC_MOVE_STATIC_FIELD,
        TPC_MOVE_STATIC_METHOD,
        TPC_TURN_DYN_METHOD_TO_STATIC,
        TPC_TURN_STATIC_METHOD_TO_DYN,
        TPC_PULL_UP_METHOD,
        TPC_PUSH_DOWN_METHOD,
        TPC_PUSH_DOWN_METHOD_POST_CHECK,
        TPC_PULL_UP_FIELD,
        TPC_PUSH_DOWN_FIELD,
        TPC_GET_LAST_IMPORT_LINE,
};
enum extractModes {
        EXTR_FUNCTION,
        EXTR_FUNCTION_ADDRESS_ARGS,
        EXTR_MACRO,
};
enum editors {
        ED_NONE,
        ED_EMACS,
        ED_JEDIT,
};
enum memories {
        MEM_CF,
        MEM_XX,
        MEM_PP,
};
enum refCategories {
        CatGlobal,
        CatLocal,
        MAX_CATEGORIES
};
enum refScopes {
        ScopeDefault,
        ScopeGlobal,
        ScopeFile,
        ScopeAuto,
        MAX_SCOPES
};
enum usages {
        ureserve0,
        UsageOLBestFitDefined,
        UsageJavaNativeDeclared,
        ureserve1,
        UsageDefined,
        ureserve2,
        UsageDeclared,
        ureserve3,
        UsageLvalUsed,
        UsageLastUselessInClassOrMethod,
        ureserve4,
        UsageAddrUsed,
        ureserve5,
        UsageConstructorUsed,
        ureserve6,
        UsageMaybeThisInClassOrMethod,
        UsageMaybeQualifThisInClassOrMethod,
        UsageNotFQTypeInClassOrMethod,
        UsageNotFQFieldInClassOrMethod,
        UsageNonExpandableNotFQTNameInClassOrMethod,
        UsageLastUseless,
        ureserve7,
        UsageUsed,
        UsageUndefinedMacro,
        UsageMethodInvokedViaSuper,
        UsageConstructorDefinition,
        ureserve8,
        UsageOtherUseless,
        UsageThisUsage,
        ureserve9,
        UsageFork,
        ureserve10,
        ureserve11,
        UsageMaxOLUsages,
        UsageNone,
        UsageMacroBaseFileUsage,
        UsageClassFileDefinition,
        UsageJavaDoc,
        UsageJavaDocFullEntry,
        UsageClassTreeDefinition,
        UsageMaybeThis,
        UsageMaybeQualifiedThis,
        UsageThrown,
        UsageCatched,
        UsageTryCatchBegin,
        UsageTryCatchEnd,
        UsageSuperMethod,
        UsageNotFQType,
        UsageNotFQField,
        UsageNonExpandableNotFQTName,
        MAX_USAGES,
        USAGE_ANY,
        USAGE_FILTER,
};
enum menuFilterLevels {
        FilterAllOfSameName,
        FilterSameProfile,
        FilterSameProfileRelatedClass,
        MAX_MENU_FILTER_LEVEL,
};
enum refsFilterLevels {
        RFilterAll,
        RFilterAddrVal,
        RFilterLVal,
        RFilterDefinitions,
        MAX_REF_LIST_FILTER_LEVEL,
};
enum storages {
        StorageError,
        StorageAuto,
        StorageGlobal,
        StorageDefault,
        StorageExtern,
        StorageConstant,
        StorageStatic,
        StorageTypedef,
        StorageMutable,
        StorageRegister,
        StorageConstructor,
        StorageField,
        StorageMethod,
        StorageNone,
        MAX_STORAGE,
};
enum types {
        TypeDefault,
        TypeChar ,
        TypeUnsignedChar ,
        TypeSignedChar ,
        TypeInt ,
        TypeUnsignedInt ,
        TypeSignedInt ,
        TypeShortInt ,
        TypeShortUnsignedInt ,
        TypeShortSignedInt ,
        TypeLongInt ,
        TypeLongUnsignedInt ,
        TypeLongSignedInt ,
        TypeFloat ,
        TypeDouble ,
        TypeStruct,
        TypeUnion,
        TypeEnum ,
        TypeVoid ,
        TypePointer,
        TypeArray,
        TypeFunction,
        TypeAnonymeField,
        TypeError,
        MODIFIERS_START,
        TmodLong,
        TmodShort,
        TmodSigned,
        TmodUnsigned,
        TmodShortSigned,
        TmodShortUnsigned,
        TmodLongSigned,
        TmodLongUnsigned,
        TypeReserve1,
        TypeReserve2,
        TypeReserve3,
        TypeReserve4,
        MODIFIERS_END,
        TypeElipsis,
        JAVA_TYPES,
        TypeByte,
        TypeShort,
        TypeLong,
        TypeBoolean,
        TypeNull,
        TypeOverloadedFunction,
        TypeReserve7,
        TypeReserve8,
        TypeReserve9,
        TypeReserve10,
        TypeReserve11,
        CCC_TYPES,
        TypeWchar_t,
        MAX_CTYPE,
        TypeCppInclude,
        TypeMacro,
        TypeCppIfElse,
        TypeCppCollate,
        TypePackage,
        TypeYaccSymbol,
        MAX_HTML_LIST_TYPE,
        TypeLabel,
        TypeKeyword,
        TypeToken,
        TypeUndefMacro,
        TypeMacroArg,
        TypeDefinedOp,
        TypeCppAny,
        TypeBlockMarker,
        TypeTryCatchMarker,
        TypeComment,
        TypeExpression,
        TypePackedType,
        TypeFunSep,
        TypeSpecialComplet,
        TypeNonImportedClass,
        TypeInducedError,
        TypeInheritedFullMethod,
        TypeSpecialConstructorCompletion,
        TypeUnknown,
        MAX_TYPE,
};
enum javaPCTIndex {
        PCTIndexError=0,
        PCTIndexByte,
        PCTIndexShort,
        PCTIndexChar,
        PCTIndexInt,
        PCTIndexLong,
        PCTIndexFloat,
        PCTIndexDouble,
        MAX_PCTIndex
};
enum copyFlag {
        FillGenerate,
        InternalFillGenerate,
        CopyGenerate,
};
enum sFunResult {
        RESULT_OK,
        RESULT_ERR
};
enum inputType {
        II_NORMAL,
        II_MACRO,
        II_MACRO_ARG,
        II_CACHE,
};
enum updateModifiers {
        UP_NO_UPDATE = 0,
        UP_FAST_UPDATE,
        UP_FULL_UPDATE,
};
enum syntaxPassParsedImportantPosition {
        SPP_LAST_TOP_LEVEL_CLASS_POSITION,
        SPP_ASSIGNMENT_OPERATOR_POSITION,
        SPP_ASSIGNMENT_END_POSITION,
        SPP_CLASS_DECLARATION_BEGIN_POSITION,
        SPP_CLASS_DECLARATION_END_POSITION,
        SPP_CLASS_DECLARATION_TYPE_BEGIN_POSITION,
        SPP_CLASS_DECLARATION_TYPE_END_POSITION,
        SPP_METHOD_DECLARATION_BEGIN_POSITION,
        SPP_METHOD_DECLARATION_END_POSITION,
        SPP_METHOD_DECLARATION_TYPE_BEGIN_POSITION,
        SPP_METHOD_DECLARATION_TYPE_END_POSITION,
        SPP_FIELD_DECLARATION_BEGIN_POSITION,
        SPP_FIELD_DECLARATION_END_POSITION,
        SPP_FIELD_DECLARATION_TYPE_BEGIN_POSITION,
        SPP_FIELD_DECLARATION_TYPE_END_POSITION,
        SPP_CAST_LPAR_POSITION,
        SPP_CAST_RPAR_POSITION,
        SPP_CAST_TYPE_BEGIN_POSITION,
        SPP_CAST_TYPE_END_POSITION,
        SPP_CAST_EXPRESSION_BEGIN_POSITION,
        SPP_CAST_EXPRESSION_END_POSITION,
        SPP_PARENTHESED_EXPRESSION_LPAR_POSITION,
        SPP_PARENTHESED_EXPRESSION_RPAR_POSITION,
        SPP_PARENTHESED_EXPRESSION_BEGIN_POSITION,
        SPP_PARENTHESED_EXPRESSION_END_POSITION,
        SPP_MAX,
};
struct fileStat {
        char validFlag;
        struct stat stat;
};
struct cctNode {
        S_symbol *node;
        S_cctNode *sub;
};
struct position {
        int file;
        int line;
        int coll;
};
struct positionLst {
        S_position p;
        S_positionLst *next;
};
struct idIdent {
        char *name;
        S_symbol *sd;
        S_position p;
};
struct freeTrail {
        void (*action)();
        void *p;
        S_freeTrail *next;
};
struct topBlock {
        int firstFreeIndex;
        int tmpMemoryBasei;
        S_freeTrail *trail;
        S_topBlock *previousTopBlock;
};
struct typeModifiers {
        short m;
        union typeModifUnion {
                struct funTypeModif {
                        S_symbol *args;
                        S_symbol **thisFunList;
                } f;
                struct methodTypeModif {
                        char *sig;
                        S_symbolList *exceptions;
                } m;
                S_symbol *t;
        } u;
        S_symbol *typedefin;
        S_typeModifiers *next;
};
struct typeModifiersList {
        S_typeModifiers *d;
        S_typeModifiersList *next;
};
struct recFindStr {
        S_symbol *baseClass;
        S_symbol *currClass;
        S_symbol *nextRecord;
        unsigned recsClassCounter;
        int sti;
        S_symbolList *st[MAX_INHERITANCE_DEEP];
        int aui;
        S_symbol *au[MAX_ANONYMOUS_FIELDS];
};
struct extRecFindStr {
        S_recFindStr s;
        S_symbol *memb;
        S_typeModifiersList *params;
};
struct nestedSpec {
        S_symbol *cl;
        char membFlag;
        short unsigned accFlags;
};
struct symStructSpecific {
        S_symbolList *super;
        S_symbol *records;
        S_cctNode casts;
        short int nnested;
        S_nestedSpec *nest;
        S_typeModifiers stype;
        S_typeModifiers sptrtype;
        char currPackage;
        char existsDEIarg;
        int classFile;
        unsigned recSearchCounter;
};
struct symbol {
        char *name;
        char *linkName;
        S_position pos;
        struct symbolBits {
                unsigned record : 1;
                unsigned isSingleImported: 1;
                unsigned accessFlags : 12;
                unsigned javaSourceLoaded: 1;
                unsigned javaFileLoaded : 1;
                unsigned symType : 7;
                unsigned storage : 5;
                unsigned npointers : 4;
        } b;
        union defUnion {
                S_typeModifiers *type;
                S_symStructSpecific *s;
                S_symbolList *enums;
                S_macroBody *mbody;
                int labn;
                int keyWordVal;
        } u;
        S_symbol *next;
};
struct symbolList {
        S_symbol *d;
        S_symbolList *next;
};
struct jslSymbolList {
        S_symbol *d;
        S_position pos;
        int isSingleImportedFlag;
        S_jslSymbolList *next;
};
struct usageBits {
        unsigned base:8;
        unsigned requiredAccess:2;
        unsigned dummy:1;
};
struct reference {
        S_usageBits usg;
        S_position p;
        S_reference *next;
};
struct symbolRefItem {
        char *name;
        unsigned fileHash;
        int vApplClass;
        int vFunClass;
        struct symbolRefItemBits {
                unsigned symType : 7;
                unsigned storage : 5;
                unsigned scope : 3;
                unsigned accessFlags : 12;
                unsigned category : 2;
                unsigned htmlWasLn : 1;
        } b;
        S_reference *refs;
        S_symbolRefItem *next;
};
struct symbolRefItemList {
        S_symbolRefItem *d;
        S_symbolRefItemList *next;
};
struct chReference {
        int ofile;
        int clas;
        S_chReference *next;
};
struct cxScanFileFunctionLink {
        int recordCode;
        void (*handleFun)();
        int additionalArg;
};
struct olCompletion {
        char *name;
        char *fullName;
        char *vclass;
        short int jindent;
        short int lineCount;
        char cat;
        char csymType;
        S_reference ref;
        S_symbolRefItem sym;
        S_olCompletion *next;
};
struct olSymbolFoundInformation {
        S_symbolRefItem *symrefs;
        S_symbolRefItem *symRefsInfo;
        S_reference *currentRef;
};
struct olSymbolsMenu {
        S_symbolRefItem s;
        char selected;
        char visible;
        unsigned ooBits;
        char olUsage;
        short int vlevel;
        short int refn;
        short int defRefn;
        char defUsage;
        S_position defpos;
        int outOnLine;
        S_editorMarkerList *markers;
        S_olSymbolsMenu *next;
};
struct olcxReferences {
        S_reference *r;
        S_reference *act;
        char command;
        char language;
        time_t atime;
        char refsuffix[MAX_OLCX_SUFF_SIZE];
        S_position cpos;
        S_olCompletion *cpls;
        S_olSymbolsMenu *hkSelectedSym;
        S_olSymbolsMenu *menuSym;
        int menuFilterLevel;
        int refsFilterLevel;
        S_olcxReferences *previous;
};
struct classTreeData {
        char refsuffix[MAX_OLCX_SUFF_SIZE];
        int baseClassIndex;
        S_olSymbolsMenu *tree;
};
struct olcxReferencesStack {
        S_olcxReferences *top;
        S_olcxReferences *root;
};
struct userOlcx {
        char *name;
        S_olcxReferencesStack browserStack;
        S_olcxReferencesStack completionsStack;
        S_olcxReferencesStack retrieverStack;
        S_classTreeData ct;
        S_userOlcx *next;
};
struct fileItem {
        char *name;
        time_t lastModif;
        time_t lastInspect;
        time_t lastUpdateMtime;
        time_t lastFullUpdateMtime;
        struct fileItemBits {
                unsigned cxLoading: 1;
                unsigned cxLoaded : 1;
                unsigned cxSaved : 1;
                unsigned commandLineEntered : 1;
                unsigned scheduledToProcess : 1;
                unsigned scheduledToUpdate : 1;
                unsigned fullUpdateIncludesProcessed : 1;
                unsigned isInterface : 1;
                unsigned isFromCxfile : 1;
                unsigned sourceFile : 20;
        } b;
        S_chReference *sups;
        S_chReference *infs;
        int directEnclosingInstance;
        S_fileItem *next;
};
struct fileItemList {
        S_fileItem *d;
        S_fileItemList *next;
};
struct cline {
        char *s;
        S_symbol *t;
        short int symType;
        short int virtLevel;
        short int margn;
        char **margs;
        S_symbol *vFunClass;
};
struct completions {
        char idToProcess[MAX_FUN_NAME_SIZE];
        int idToProcessLen;
        S_position idToProcessPos;
        int fullMatchFlag;
        int isCompleteFlag;
        int noFocusOnCompletions;
        int abortFurtherCompletions;
        char comPrefix[TMP_STRING_SIZE];
        int maxLen;
        S_cline a[MAX_COMPLETIONS];
        int ai;
};
struct completionFunTab {
        int token;
        void (*fun)();
};
struct completionSymFunInfo {
        S_completions *res;
        unsigned storage;
};
struct completionSymInfo {
        S_completions *res;
        unsigned symType;
};
struct completionFqtMapInfo {
        S_completions *res;
        int completionType;
};
struct tokenNameIni {
        char *name;
        int token;
        unsigned languages;
};
struct typeCharCodeIni {
        int symType;
        char code;
};
struct javaTypePCTIConvertIni {
        int symType;
        int PCTIndex;
};
struct typeModificationsInit {
        int type;
        int modShort;
        int modLong;
        int modSigned;
        int modUnsigned;
};
struct intStringTab {
        int i;
        char *s;
};
struct currentlyParsedCl {
        S_symbol *function;
        S_extRecFindStr *erfsForParamsComplet;
        unsigned funBegPosition;
        int cxMemiAtFunBegin;
        int cxMemiAtFunEnd;
        int cxMemiAtClassBegin;
        int cxMemiAtClassEnd;
        int thisMethodMemoriesStored;
        int thisClassMemoriesStored;
        int parserPassedMarker;
};
struct currentlyParsedStatics {
        int extractProcessedFlag;
        int cxMemiAtBlockBegin;
        int cxMemiAtBlockEnd;
        S_topBlock *workMemiAtBlockBegin;
        S_topBlock *workMemiAtBlockEnd;
        int marker1Flag;
        int marker2Flag;
        char setTargetAnswerClass[TMP_STRING_SIZE];
        int moveTargetApproved;
        char currentPackageAnswer[TMP_STRING_SIZE];
        char currentClassAnswer[TMP_STRING_SIZE];
        char currentSuperClassAnswer[TMP_STRING_SIZE];
        int methodCoordEndLine;
        int cxMemiAtMethodBeginning;
        int cxMemiAtMethodEnd;
        int classCoordEndLine;
        int cxMemiAtClassBeginning;
        int cxMemiAtClassEnd;
        int lastImportLine;
        S_symbol *lastDeclaratorType;
        S_symbol *lastAssignementStruct;
};
struct javaStat {
        S_idIdentList *className;
        S_typeModifiers *thisType;
        S_symbol *thisClass;
        int currentNestIndex;
        char *currentPackage;
        char *unNamedPackageDir;
        char *namedPackageDir;
        S_symTab *locals;
        S_idIdentList *lastParsedName;
        unsigned cpMethodMods;
        S_currentlyParsedCl cp;
        int classFileInd;
        S_javaStat *next;
};
struct idIdentList {
        S_idIdent idi;
        char *fname;
        uchar nameType;
        S_idIdentList *next;
};
struct zipArchiveDir {
        union {
                S_zipArchiveDir *sub;
                unsigned offset;
        } u;
        S_zipArchiveDir *next;
        char name[1];
};
struct zipFileTabItem {
        char fn[MAX_FILE_NAME_SIZE];
        struct stat st;
        S_zipArchiveDir *dir;
};
struct counters {
        int localSym;
        int localVar;
        int anonymousClassCounter;
};
struct cachePoint {
        S_topBlock *topBlock;
        S_topBlock starTopBlock;
        int ppmMemoryi;
        int cxMemoryi;
        int mbMemoryi;
        char *lbcc;
        short int ibi;
        short int lineNumber;
        short int ifDeep;
        S_cppIfStack *ifstack;
        S_javaStat *javaCached;
        S_counters counts;
};
struct caching {
        char activeCache;
        int cpi;
        S_cachePoint cp[MAX_CACHE_POINTS];
        int ibi;
        int ib[INCLUDE_CACHE_SIZE];
        char *lbcc;
        char lb[LEX_BUF_CACHE_SIZE];
        char *lexcc;
        char *cc;
        char *cfin;
};
struct stringList {
        char *d;
        struct stringList *next;
};
struct stringAddrList {
        char **d;
        struct stringAddrList *next;
};
struct macroArgTabElem {
        char *name;
        char *linkName;
        int order;
};
struct macroBody {
        short int argn;
        int size;
        char *name;
        char **args;
        char *body;
};
struct charBuf {
        char *cc;
        char *fin;
        char a[CHAR_BUFF_SIZE];
        FILE *ff;
        unsigned filePos;
        int fileNumber;
        int lineNum;
        char *lineBegin;
        short int collumnOffset;
        char isAtEOF;
        char inputMethod;
        char z[CHAR_BUFF_SIZE];
        z_stream zipStream;
};
struct lexBuf {
        char *cc;
        char *fin;
        char a[LEX_BUFF_SIZE];
        S_position pRing[LEX_POSITIONS_RING_SIZE];
        unsigned fpRing[LEX_POSITIONS_RING_SIZE];
        int posi;
        S_charBuf cb;
};
struct cppIfStack {
        S_position pos;
        S_cppIfStack *next;
};
struct fileDesc {
        char *fileName ;
        int lineNumber ;
        int ifDeep;
        S_cppIfStack *ifstack;
        struct lexBuf lb;
};
struct lexInput {
        char *cc;
        char *fin;
        char *a;
        char *macname;
        char margExpFlag;
};
struct memory {
        int (*overflowHandler)(int n);
        int i;
        int size;
        double b;
};
struct intlist {
        int i;
        S_intlist *next;
};
struct disabledList {
        int file;
        int clas;
        S_disabledList *next;
};
struct htmlData {
        S_position *cp;
        S_reference *np;
        S_symbolRefItem *nri;
};
struct htmlRefList {
        S_symbolRefItem *s;
        S_reference *r;
        S_symbolRefItem *slist;
        S_htmlRefList *next;
};
struct htmlLocalListms {
        FILE *ff;
        int fnum;
        char *fname;
};
struct programGraphNode {
        S_reference *ref;
        S_symbolRefItem *symRef;
        S_programGraphNode *jump;
        char posBits;
        char stateBits;
        char classifBits;
        S_programGraphNode *next;
};
struct exprTokenType {
        S_typeModifiers *t;
        S_reference *r;
        S_position *pp;
};
struct nestedConstrTokenType {
        S_typeModifiers *t;
        S_idIdentList *nid;
        S_position *pp;
};
struct unsPositionPair {
        unsigned u;
        S_position *p;
};
struct symbolPositionPair {
        S_symbol *s;
        S_position *p;
};
struct symbolPositionLstPair {
        S_symbol *s;
        S_positionLst *p;
};
struct intPair {
        int i1;
        int i2;
};
struct typeModifiersListPositionLstPair {
        S_typeModifiersList *t;
        S_positionLst *p;
};
struct whileExtractData {
        int i1;
        int i2;
        S_symbol *i3;
        S_symbol *i4;
};
struct referencesChangeData {
        char *linkName;
        int fnum;
        S_symbol *cclass;
        int category;
        int cxMemBegin;
        int cxMemEnd;
};
struct pushAllInBetweenData {
        int minMemi;
        int maxMemi;
};
struct tpCheckSpecialReferencesData {
        S_pushAllInBetweenData mm;
        char *symbolToTest;
        int classToTest;
        S_symbolRefItem *foundSpecialRefItem;
        S_reference *foundSpecialR;
        S_symbolRefItem *foundRefToTestedClass;
        S_symbolRefItem *foundRefNotToTestedClass;
        S_reference *foundOuterScopeRef;
};
struct tpCheckMoveClassData {
        S_pushAllInBetweenData mm;
        char *spack;
        char *tpack;
        int transPackageMove;
        char *sclass;
};
struct jslClassStat {
        S_idIdentList *className;
        S_symbol *thisClass;
        char *thisPackage;
        int annonInnerCounter;
        int functionInnerCounter;
        S_jslClassStat *next;
};
struct jslStat {
        int pass;
        int sourceFileNumber;
        int language;
        S_jslTypeTab *typeTab;
        S_jslClassStat *classStat;
        S_symbolList *waitList;
        void *savedyylval;
        struct yyGlobalState *savedYYstate;
        int yyStateSize;
        S_idIdent yyIdentBuf[YYBUFFERED_ID_INDEX];
        S_jslStat *next;
};
struct editorBuffer {
        char *name;
        int ftnum;
        char *fileName;
        struct stat stat;
        S_editorMarker *markers;
        struct editorBufferAllocationData {
                int bufferSize;
                char *text;
                int allocatedFreePrefixSize;
                char *allocatedBlock;
                int allocatedIndex;
                int allocatedSize;
        } a;
        struct editorBufferBits {
                unsigned textLoaded:1;
                unsigned modified:1;
                unsigned modifiedSinceLastQuasySave:1;
        } b;
};
struct editorBufferList {
        S_editorBuffer *f;
        S_editorBufferList *next;
};
struct editorMemoryBlock {
        struct editorMemoryBlock *next;
};
struct editorMarker {
        S_editorBuffer *buffer;
        unsigned offset;
        struct editorMarker *previous;
        struct editorMarker *next;
};
struct editorMarkerList {
        S_editorMarker *d;
        S_usageBits usg;
        S_editorMarkerList *next;
};
struct editorRegion {
        S_editorMarker *b;
        S_editorMarker *e;
};
struct editorRegionList {
        S_editorRegion r;
        S_editorRegionList *next;
};
struct editorUndo {
        S_editorBuffer *buffer;
        int operation;
        union editorUndoUnion {
                struct editorUndoStrReplace {
                        unsigned offset;
                        unsigned size;
                        unsigned strlen;
                        char *str;
                } replace;
                struct editorUndoRenameBuff {
                        char *name;
                } rename;
                struct editorUndoMoveBlock {
                        unsigned offset;
                        unsigned size;
                        S_editorBuffer *dbuffer;
                        unsigned doffset;
                } moveBlock;
        } u;
        S_editorUndo *next;
};
struct availableRefactoring {
        unsigned available;
        char *option;
};
struct bb_int {
        S_position b, e;
        int d;
};
struct bb_unsigned {
        S_position b, e;
        unsigned d;
};
struct bb_symbol {
        S_position b, e;
        S_symbol *d;
};
struct bb_symbolList {
        S_position b, e;
        S_symbolList *d;
};
struct bb_typeModifiers {
        S_position b, e;
        S_typeModifiers *d;
};
struct bb_typeModifiersList {
        S_position b, e;
        S_typeModifiersList *d;
};
struct bb_freeTrail {
        S_position b, e;
        S_freeTrail *d;
};
struct bb_idIdent {
        S_position b, e;
        S_idIdent *d;
};
struct bb_idIdentList {
        S_position b, e;
        S_idIdentList *d;
};
struct bb_exprTokenType {
        S_position b, e;
        S_exprTokenType d;
};
struct bb_nestedConstrTokenType {
        S_position b, e;
        S_nestedConstrTokenType d;
};
struct bb_intPair {
        S_position b, e;
        S_intPair d;
};
struct bb_whileExtractData {
        S_position b, e;
        S_whileExtractData *d;
};
struct bb_position {
        S_position b, e;
        S_position d;
};
struct bb_unsPositionPair {
        S_position b, e;
        S_unsPositionPair d;
};
struct bb_symbolPositionPair {
        S_position b, e;
        S_symbolPositionPair d;
};
struct bb_symbolPositionLstPair {
        S_position b, e;
        S_symbolPositionLstPair d;
};
struct bb_positionLst {
        S_position b, e;
        S_positionLst *d;
};
struct bb_typeModifiersListPositionLstPair {
        S_position b, e;
        S_typeModifiersListPositionLstPair d;
};
struct htmlCutPathesOpts {
        int pathesNum;
        char *path[MAX_HTML_CUT_PATHES];
        int plen[MAX_HTML_CUT_PATHES];
};
struct setGetEnv {
        int num;
        char *name[MAX_SET_GET_OPTIONS];
        char *value[MAX_SET_GET_OPTIONS];
};
struct options {
        int fileEncoding;
        char completeParenthesis;
        int defaultAddImportStrategy;
        char referenceListWithoutSource;
        char jeditOldCompletions;
        int completionOverloadWizardDeep;
        int exit;
        int commentMovingLevel;
        S_stringList *pruneNames;
        S_stringList *inputFiles;
        int continueRefactoring;
        int completionCaseSensitive;
        char *xrefrc;
        int eolConversion;
        char *checkVersion;
        int nestedClassDisplaying;
        char *pushName;
        int parnum2;
        char *refpar1;
        char *refpar2;
        int theRefactoring;
        int briefoutput;
        int cacheIncludes;
        int stdopFlag;
        char *renameTo;
        int refactoringRegime;
        int xref2;
        char *moveTargetFile;
        char *cFilesSuffixes;
        char *javaFilesSuffixes;
        char *cppFilesSuffixes;
        int fileNamesCaseSensitive;
        char *htmlLineNumLabel;
        int htmlCutSuffix;
        int tagSearchSpecif;
        char *javaVersion;
        char *olcxWinDelFile;
        int olcxWinDelFromLine;
        int olcxWinDelFromCol;
        int olcxWinDelToLine;
        int olcxWinDelToCol;
        char *moveFromUser;
        int noErrors;
        int fqtNameToCompletions;
        char *moveTargetClass;
        int trivialPreCheckCode;
        int urlGenTemporaryFile;
        int urlAutoRedirect;
        int javaFilesOnly;
        int exactPositionResolve;
        char *outputFileName;
        char *lineFileName;
        S_stringList *includeDirs;
        char *cxrefFileName;
        char *checkFileMovedFrom;
        char *checkFileMovedTo;
        int checkFirstMovedLine;
        int checkLinesMoved;
        int checkNewLineNumber;
        char *getValue;
        int java2html;
        int javaSlAllowed;
        int xfileHashingMethod;
        char *htmlLineNumColor;
        int htmlCxLineLen;
        char *htmlJdkDocAvailable;
        int htmlGenJdkDocLinks;
        char *htmlJdkDocUrl;
        char *javaDocPath;
        int allowPackagesOnCl;
        char *sourcePath;
        int htmlDirectX;
        char *jdocTmpDir;
        int noCxFile;
        int javaDoc;
        int noIncludeRefs;
        int allowClassFileRefs;
        int filterValue;
        char *jdkClassPath;
        int manualResolve;
        char *browsedSymName;
        int modifiedFlag;
        int olcxMenuSelectLineNum;
        int htmlNoUnderline;
        char *htmlLinkColor;
        char *htmlCutPath;
        int htmlCutPathLen;
        int ooChecksBits;
        int htmlLineNums;
        int htmlNoColors;
        int cxMemoryFaktor;
        int multiHeadRefsCare;
        int strictAnsi;
        char * project;
        int updateOnlyModifiedFiles;
        char *olcxlccursor;
        char *htmlZipCommand;
        char *olcxSearchString;
        int olineLen;
        char licenseString[TMP_STRING_SIZE];
        char *htmlLinkSuffix;
        char *olExtractAddrParPrefix;
        int extractMode;
        int htmlFunSeparate;
        int maxCompletions;
        int editor;
        int create;
        char *olcxRefSuffix;
        int recursivelyDirs;
        char *classpath;
        int tabulator;
        char *htmlRoot;
        int htmlRichLists;
        int htmlglobalx;
        int htmllocalx;
        int cIsCplusplus;
        int olCursorPos;
        int olMarkPos;
        int taskRegime;
        char *user;
        int debug;
        int cpp_comment;
        int c_struct_scope;
        int cxrefs;
        int olcxGotoVal;
        char *originalDir;
        int no_ref_locals;
        int no_ref_records;
        int no_ref_enumerator;
        int no_ref_typedef;
        int no_ref_macro;
        int no_stdop;
        int qnxMessages;
        int typedefg;
        int str_fill;
        int enum_name;
        int body;
        int header;
        int str_copy;
        int err;
        int long_cxref;
        int brief;
        int update;
        int keep_old;
        char *last_message;
        int refnum;
        S_setGetEnv setGetEnv;
        S_htmlCutPathesOpts htmlCut;
        S_stringAddrList *allAllocatedStrings;
        S_memory pendingMemory;
        char pendingFreeSpace[SIZE_opiMemory];
};
struct optionsList {
        char *section;
        S_stringList *opts;
        S_options flgopts;
        S_optionsList *next;
};
struct symTab {
        int size;
        S_symbol **tab;
};
extern void symTabInit ();
extern void symTabNAInit ();
extern int symTabIsMember ();
int symTabMembEqual ();
int symTabNextMember ();
void symTabSet ();
void symTabSetLast ();
extern void symTabAdd ();
int symTabDelete ();
int symTabDeleteExact ();
int symTabDeleteLast ();
extern void symTabFree ();
extern void symTabMap ();
extern void symTabMap2 ();
extern void symTabMap3 ();
extern void symTabMap31 ();
extern void symTabMap32 ();
extern void symTabMap4 ();
extern void symTabMap5 ();
void symTabStatistics ();
struct javaFqtTab {
        int size;
        S_symbolList **tab;
};
extern void javaFqtTabInit ();
extern void javaFqtTabNAInit ();
extern int javaFqtTabIsMember ();
int javaFqtTabMembEqual ();
int javaFqtTabNextMember ();
void javaFqtTabSet ();
void javaFqtTabSetLast ();
extern void javaFqtTabAdd ();
int javaFqtTabDelete ();
int javaFqtTabDeleteExact ();
int javaFqtTabDeleteLast ();
extern void javaFqtTabFree ();
extern void javaFqtTabMap ();
extern void javaFqtTabMap2 ();
extern void javaFqtTabMap3 ();
extern void javaFqtTabMap31 ();
extern void javaFqtTabMap32 ();
extern void javaFqtTabMap4 ();
extern void javaFqtTabMap5 ();
void javaFqtTabStatistics ();
struct jslTypeTab {
        int size;
        S_jslSymbolList **tab;
};
extern void jslTypeTabInit ();
extern void jslTypeTabNAInit ();
extern int jslTypeTabIsMember ();
int jslTypeTabMembEqual ();
int jslTypeTabNextMember ();
void jslTypeTabSet ();
void jslTypeTabSetLast ();
extern void jslTypeTabAdd ();
int jslTypeTabDelete ();
int jslTypeTabDeleteExact ();
int jslTypeTabDeleteLast ();
extern void jslTypeTabFree ();
extern void jslTypeTabMap ();
extern void jslTypeTabMap2 ();
extern void jslTypeTabMap3 ();
extern void jslTypeTabMap31 ();
extern void jslTypeTabMap32 ();
extern void jslTypeTabMap4 ();
extern void jslTypeTabMap5 ();
void jslTypeTabStatistics ();
struct refTab {
        int size;
        S_symbolRefItem **tab;
};
extern void refTabInit ();
extern void refTabNAInit ();
extern int refTabIsMember ();
int refTabMembEqual ();
int refTabNextMember ();
void refTabSet ();
void refTabSetLast ();
extern void refTabAdd ();
int refTabDelete ();
int refTabDeleteExact ();
int refTabDeleteLast ();
extern void refTabFree ();
extern void refTabMap ();
extern void refTabMap2 ();
extern void refTabMap3 ();
extern void refTabMap31 ();
extern void refTabMap32 ();
extern void refTabMap4 ();
extern void refTabMap5 ();
void refTabStatistics ();
struct idTab {
        int size;
        int numberOfElements;
        S_fileItem **tab;
};
extern void idTabInit ();
extern void idTabNAInit ();
extern int idTabIsMember ();
void idTabSet ();
extern void idTabAdd ();
extern void idTabFree ();
extern void idTabMap ();
extern void idTabMap2 ();
extern void idTabMap4 ();
extern void idTabMap3 ();
struct editorBufferTab {
        int size;
        S_editorBufferList **tab;
};
extern void editorBufferTabInit ();
extern void editorBufferTabNAInit ();
extern int editorBufferTabIsMember ();
int editorBufferTabMembEqual ();
int editorBufferTabNextMember ();
void editorBufferTabSet ();
void editorBufferTabSetLast ();
extern void editorBufferTabAdd ();
int editorBufferTabDelete ();
int editorBufferTabDeleteExact ();
int editorBufferTabDeleteLast ();
extern void editorBufferTabFree ();
extern void editorBufferTabMap ();
extern void editorBufferTabMap2 ();
extern void editorBufferTabMap3 ();
extern void editorBufferTabMap31 ();
extern void editorBufferTabMap32 ();
extern void editorBufferTabMap4 ();
extern void editorBufferTabMap5 ();
void editorBufferTabStatistics ();
void emergencyExit ();
extern void warning ();
extern void error ();
extern void fatalError ();
extern void internalCheckFail ();
void cctAddSimpleValue ();
int cctIsMember ();
void cctAddCctTree ();
void cctDump ();
void cctTest ();
void ppcGenSynchroRecord ();
void ppcIndentOffset ();
void ppcGenGotoOffsetPosition ();
void ppcGenRecordBegin ();
void ppcGenRecordWithAttributeBegin ();
void ppcGenRecordWithNumAttributeBegin ();
void ppcGenRecordEnd ();
void ppcGenNumericRecordBegin ();
void ppcGenTwoNumericAndRecordBegin ();
void ppcGenWithNumericAndRecordBegin ();
void ppcGenAllCompletionsRecordBegin ();
void ppcGenTwoNumericsAndrecord ();
void ppcGenRecordWithNumeric ();
void ppcGenNumericRecord ();
void ppcGenRecord ();
void ppcGenTmpBuff ();
void ppcGenDisplaySelectionRecord ();
void ppcGenGotoMarkerRecord ();
void ppcGenPosition ();
void ppcGenDefinitionNotFoundWarning ();
void ppcGenDefinitionNotFoundWarningAtBottom ();
void ppcGenReplaceRecord ();
void ppcGenPreCheckRecord ();
void ppcGenReferencePreCheckRecord ();
void ppcGenGotoPositionRecord ();
void ppcGenOffsetPosition ();
void ppcGenMarker ();
char * stringNumStr ();
void jarFileParse ();
void scanJarFilesForTagSearch ();
void classFileParse ();
void fillTrivialSpecialRefItem ();
void setExpirationFromLicenseString ();
int optionsOverflowHandler ();
int cxMemoryOverflowHandler ();
void noSuchRecordError ();
void methodAppliedOnNonClass ();
void methodNameNotRecognized ();
void dumpOptions ();
void stackMemoryInit ();
void *stackMemoryAlloc ();
void *stackMemoryPush ();
int *stackMemoryPushInt ();
char *stackMemoryPushString ();
void stackMemoryPop ();
void stackMemoryBlockStart ();
void stackMemoryBlockFree ();
void stackMemoryStartErrZone ();
void stackMemoryStopErrZone ();
void stackMemoryErrorInZone ();
void stackMemoryDump ();
void addToTrail ();
void removeFromTrailUntil ();
void symDump ();
void symbolRefItemDump ();
int javaTypeStringSPrint ();
void typeSPrint ();
void throwsSprintf ();
void macDefSPrintf ();
char * string3ConcatInStackMem ();
unsigned hashFun ();
void javaSignatureSPrint ();
void fPutDecimal ();
char *strmcpy ();
char *simpleFileName ();
char *directoryName_st ();
char *simpleFileNameWithoutSuffix_st ();
int containsWildCharacter ();
int shellMatch ();
void expandWildCharactersInOnePathRec ();
void expandWildCharactersInOnePath ();
void expandWildCharactersInPaths ();
char * getRealFileNameStatic ();
char *crTmpFileName_st();
void copyFile ();
void createDir ();
void removeFile ();
int substringIndexWithLimit ();
int stringContainsSubstring ();
void javaGetPackageNameFromSourceFileName ();
int substringIndex ();
int stringEndsBySuffix ();
int fileNameHasOneOfSuffixes ();
int mapPatternFiles ();
int mapDirectoryFiles ();
void javaMapDirectoryFiles1 ();
void javaMapDirectoryFiles2 ();
char *lastOccurenceInString ();
char *lastOccurenceOfSlashOrAntiSlash ();
char * getFileSuffix ();
char *javaCutClassPathFromFileName ();
char *javaCutSourcePathFromFileName ();
int pathncmp ();
int fnCmp ();
int fnnCmp ();
void processName ();
void completeForSpecial1 ();
void completeForSpecial2 ();
void completeUpFunProfile ();
void completeTypes ();
void completeStructs ();
void completeRecNames ();
void completeEnums ();
void completeLabels ();
void completeMacros ();
void completeOthers ();
void javaCompleteTypeSingleName ();
void javaHintImportFqt ();
void javaHintVariableName ();
void javaHintCompleteNonImportedTypes ();
void javaHintCompleteMethodParameters ();
void javaCompleteTypeCompName ();
void javaCompleteThisPackageName ();
void javaCompletePackageSingleName ();
void javaCompleteExprSingleName ();
void javaCompleteUpMethodSingleName ();
void javaCompleteFullInheritedMethodHeader ();
void javaCompletePackageCompName ();
void javaCompleteExprCompName ();
void javaCompleteMethodCompName ();
void javaCompleteHintForConstructSingleName ();
void javaCompleteConstructSingleName ();
void javaCompleteConstructCompName ();
void javaCompleteConstructNestNameName ();
void javaCompleteConstructNestPrimName ();
void javaCompleteStrRecordPrimary ();
void javaCompleteStrRecordSuper ();
void javaCompleteStrRecordQualifiedSuper ();
void javaCompleteClassDefinitionNameSpecial ();
void javaCompleteClassDefinitionName ();
void javaCompleteThisConstructor ();
void javaCompleteSuperConstructor ();
void javaCompleteSuperNestedConstructor ();
void completeYaccLexem ();
char *javaGetShortClassName ();
char *javaGetShortClassNameFromFileNum_st ();
char *javaGetNudePreTypeName_st ();
void olCompletionListInit ();
void formatOutputLine ();
void printCompletionsList ();
void printCompletions ();
void generate ();
void genProjections ();
int olcxReferenceInternalLessFunction ();
int olSymbolRefItemLess ();
int searchStringFitness ();
char *crTagSearchLineStatic ();
int symbolNameShouldBeHiddenFromReports ();
void searchSymbolCheckReference ();
void tagSearchCompactShortResults();
void printTagSearchResults();
int creatingOlcxRefs();
int olcxTopSymbolExists ();
S_olSymbolsMenu *olCreateSpecialMenuItem ();
int itIsSameCxSymbol ();
int itIsSameCxSymbolIncludingFunClass ();
int itIsSameCxSymbolIncludingApplClass ();
int olcxItIsSameCxSymbol ();
void olcxRecomputeSelRefs ();
void olProcessSelectedReferences ();
void olcxPopOnly ();
S_reference * olcxCopyRefList ();
void olStackDeleteSymbol ();
int getFileNumberFromName ();
int olcxVirtualyAdequate ();
void generateOnlineCxref ();
S_reference *olcxAddReferenceNoUsageCheck ();
S_reference *olcxAddReference ();
int isRelatedClass ();
void olcxFreeReferences ();
int isSmallerOrEqClass ();
int olcxPushLessFunction ();
int olcxListLessFunction ();
char *getJavaDocUrl_st ();
char *getLocalJavaDocFile_st ();
char *getFullUrlOfJavaDoc_st ();
int htmlJdkDocAvailableForUrl ();
void setIntToZero ();
S_reference *duplicateReference ();
S_reference * addCxReferenceNew ();
S_reference * addCxReference ();
S_reference *addSpecialFieldReference ();
void addClassTreeHierarchyReference ();
void addCfClassTreeHierarchyRef ();
void addTrivialCxReference ();
int cxFileHashNumber ();
void genReferenceFile ();
void addSubClassItemToFileTab ();
void addSubClassesItemsToFileTab ();
void scanCxFile ();
void olcxAddReferences ();
void olSetCallerPosition ();
S_olCompletion * olCompletionListPrepend ();
S_olSymbolsMenu *olCreateNewMenuItem ();
S_olSymbolsMenu *olAddBrowsedSymbol ();
void renameCollationSymbols ();
void olCompletionListReverse();
S_reference **addToRefList ();
int isInRefList ();
char *getXrefEnvironmentValue ();
int byPassAcceptableSymbol ();
int itIsSymbolToPushOlRefences ();
void olcxAddReferenceToOlSymbolsMenu ();
void putOnLineLoadedReferences ();
void genOnLineReferences ();
S_olSymbolsMenu *createSelectionMenu ();
void mapCreateSelectionMenu ();
int olcxFreeOldCompletionItems ();
void olcxInit ();
S_userOlcx *olcxSetCurrentUser ();
void linkNamePrettyPrint ();
char *simpleFileNameFromFileNum ();
char *getShortClassNameFromClassNum_st ();
S_reference * getDefinitionRef ();
void printSymbolLinkNameString ();
int safetyCheck2ShouldWarn ();
void olCreateSelectionMenu ();
void printClassFqtNameFromClassNum ();
void sprintfSymbolLinkName ();
void printSymbolLinkName ();
void olcxPushEmptyStackItem ();
void olcxPrintSelectionMenu ();
int ooBitsGreaterOrEqual ();
void olcxPrintClassTree ();
void olcxReferencesDiff ();
int olcxShowSelectionMenu ();
int getClassNumFromClassLinkName ();
void getLineColCursorPositionFromCommandLineOption ();
void changeClassReferencesUsages ();
int isStrictlyEnclosingClass ();
void changeMethodReferencesUsages ();
void olcxPushSpecialCheckMenuSym ();
int refOccursInRefs ();
void olcxCheck1CxFileReference ();
void olcxPushSpecial ();
int isPushAllMethodsValidRefItem ();
int symbolsCorrespondWrtMoving ();
void olcxPrintPushingAction ();
void olPushAllReferencesInBetween ();
int tpCheckSourceIsNotInnerClass ();
void tpCheckFillMoveClassData ();
int tpCheckMoveClassAccessibilities ();
int tpCheckSuperMethodReferencesForDynToSt ();
int tpCheckOuterScopeUsagesForDynToSt ();
int tpCheckMethodReferencesWithApplOnSuperClassForPullUp ();
int tpCheckSuperMethodReferencesForPullUp ();
int tpCheckSuperMethodReferencesAfterPushDown ();
int tpCheckTargetToBeDirectSubOrSupClass ();
int tpPullUpFieldLastPreconditions ();
int tpPushDownFieldLastPreconditions ();
S_symbol *getMoveTargetClass ();
int javaGetSuperClassNumFromClassNum ();
int javaIsSuperClass ();
void pushLocalUnusedSymbolsAction ();
void mainAnswerEditAction ();
void freeOldestOlcx();
S_olSymbolsMenu *olcxFreeSymbolMenuItem ();
void olcxFreeResolutionMenu ();
int refCharCode ();
int scanReferenceFile ();
int smartReadFileTabFile();
void readOneAppropReferenceFile ();
void scanReferenceFiles ();
extern S_cxScanFileFunctionLink s_cxScanFileTab[];
extern S_cxScanFileFunctionLink s_cxFullScanFunTab[];
extern S_cxScanFileFunctionLink s_cxByPassFunTab[];
extern S_cxScanFileFunctionLink s_cxSymbolMenuCreationTab[];
extern S_cxScanFileFunctionLink s_cxSymbolLoadMenuRefs[];
extern S_cxScanFileFunctionLink s_cxScanFunTabFor2PassMacroUsage[];
extern S_cxScanFileFunctionLink s_cxScanFunTabForClassHierarchy[];
extern S_cxScanFileFunctionLink s_cxFullUpdateScanFunTab[];
extern S_cxScanFileFunctionLink s_cxHtmlGlobRefListScanFunTab[];
extern S_cxScanFileFunctionLink s_cxSymbolSearchScanFunTab[];
extern S_cxScanFileFunctionLink s_cxDeadCodeDetectionScanFunTab[];
void classHierarchyGenInit ();
void setTmpClassBackPointersToMenu ();
int chLineOrderLess ();
void splitMenuPerSymbolsAndMap ();
void htmlGenGlobRefLists ();
void genClassHierarchies ();
int classHierarchyClassNameLess ();
int classHierarchySupClassNameLess ();
void unpackPointers ();
int displayingErrorMessages ();
void deleteSymDef ();
void addSymbol ();
void recFindPush ();
S_recFindStr * iniFind ();
int javaOuterClassAccessible ();
int javaRecordAccessible ();
int javaRecordVisibleAndAccessible ();
int javaGetMinimalAccessibility ();
int findStrRecordSym ();
S_symbol *addNewSymbolDef ();
S_symbol *addNewCopyOfSymbolDef ();
S_symbol *addNewDeclaration ();
int styyerror ();
int styyErrorRecovery ();
void setToNull ();
void allocNewCurrentDefinition ();
S_symbol *typeSpecifier1 ();
void declTypeSpecifier1 ();
S_symbol *typeSpecifier2 ();
void declTypeSpecifier2 ();
void declTypeSpecifier21 ();
S_typeModifiers *appendComposedType ();
S_typeModifiers *prependComposedType ();
void completeDeclarator ();
void addFunctionParameterToSymTable ();
S_typeModifiers *crSimpleTypeMofifier ();
S_symbolList *crDefinitionList ();
S_symbol *crSimpleDefinition ();
int findStrRecord ();
S_reference * findStrRecordFromSymbol ();
S_reference * findStrRecordFromType ();
int mergeArguments ();
S_typeModifiers *simpleStrUnionSpecifier ();
S_typeModifiers *crNewAnnonymeStrUnion ();
void specializeStrUnionDef ();
S_typeModifiers *simpleEnumSpecifier ();
void setGlobalFileDepNames ();
S_typeModifiers *crNewAnnonymeEnum ();
void appendPositionToList ();
void setParamPositionForFunctionWithoutParams ();
void setParamPositionForParameter0 ();
void setParamPositionForParameterBeyondRange ();
S_symbol *crEmptyField ();
void handleDeclaratorParamPositions ();
void handleInvocationParamPositions ();
void javaHandleDeclaratorParamPositions ();
void setLocalVariableLinkName ();
void labelReference ();
void javaCheckForPrimaryStart ();
void javaCheckForPrimaryStartInNameList ();
void javaCheckForStaticPrefixStart ();
void javaCheckForStaticPrefixInNameList ();
S_position *javaGetNameStartingPosition ();
char *javaCreateComposedName ();
int findTopLevelName ();
int javaClassifySingleAmbigNameToTypeOrPack ();
void javaAddImportConstructionReference ();
int javaClassifyAmbiguousName ();
S_reference *javaClassifyToTypeOrPackageName ();
S_reference *javaClassifyToTypeName ();
S_symbol * javaQualifiedThis ();
void javaClassifyToPackageName ();
void javaClassifyToPackageNameAndAddRefs ();
char *javaImportSymbolName_st ();
S_typeModifiers *javaClassifyToExpressionName ();
S_symbol *javaTypeNameDefinition ();
void javaSetFieldLinkName ();
void javaAddPackageDefinition ();
S_symbol *javaAddType ();
S_symbol *javaCreateNewMethod ();
int javaTypeToString ();
int javaIsYetInTheClass ();
int javaSetFunctionLinkName ();
S_symbol * javaGetFieldClass ();
void javaAddNestedClassesAsTypeDefs ();
int javaTypeFileExist ();
S_symbol *javaTypeSymbolDefinition ();
S_symbol *javaTypeSymbolUsage ();
void javaReadSymbolFromSourceFileEnd ();
void javaReadSymbolFromSourceFileInit ();
void javaReadSymbolsFromSourceFileNoFreeing ();
void javaReadSymbolsFromSourceFile ();
int javaLinkNameIsAnnonymousClass ();
int javaLinkNameIsANestedClass ();
int isANestedClass ();
void addSuperMethodCxReferences ();
S_reference * addUselessFQTReference ();
S_reference *addUnimportedTypeLongReference ();
void addThisCxReferences ();
void javaLoadClassSymbolsFromFile ();
S_symbol *javaPrependDirectEnclosingInstanceArgument ();
void addMethodCxReferences ();
S_symbol *javaMethodHeader ();
void javaAddMethodParametersToSymTable ();
void javaMethodBodyBeginning ();
void javaMethodBodyEnding ();
void javaAddMapedTypeName ();
S_symbol *javaFQTypeSymbolDefinition ();
S_symbol *javaFQTypeSymbol ();
S_typeModifiers *javaClassNameType ();
S_typeModifiers *javaNewAfterName ();
int javaIsInnerAndCanGetUnnamedEnclosingInstance ();
S_typeModifiers *javaNestedNewType ();
S_typeModifiers *javaArrayFieldAccess ();
S_typeModifiers *javaMethodInvocationN ();
S_typeModifiers *javaMethodInvocationT ();
S_typeModifiers *javaMethodInvocationS ();
S_typeModifiers *javaConstructorInvocation ();
S_extRecFindStr *javaCrErfsForMethodInvocationN ();
S_extRecFindStr *javaCrErfsForMethodInvocationT ();
S_extRecFindStr *javaCrErfsForMethodInvocationS ();
S_extRecFindStr *javaCrErfsForConstructorInvocation ();
int javaClassIsInCurrentPackage ();
int javaFqtNamesAreFromTheSamePackage ();
int javaMethodApplicability ();
S_symbol *javaGetSuperClass ();
S_symbol *javaCurrentSuperClass ();
S_typeModifiers *javaCheckNumeric ();
S_typeModifiers *javaNumericPromotion ();
S_typeModifiers *javaBinaryNumericPromotion ();
S_typeModifiers *javaBitwiseLogicalPromotion ();
S_typeModifiers *javaConditionalPromotion ();
int javaIsStringType ();
void javaTypeDump ();
void javaAddJslReadedTopLevelClasses ();
struct freeTrail * newAnonClassDefinitionBegin ();
void javaAddSuperNestedClassToSymbolTab ();
struct freeTrail * newClassDefinitionBegin ();
void newClassDefinitionEnd ();
void javaInitArrayObject ();
void javaParsedSuperClass ();
void javaSetClassSourceInformation ();
void javaCheckIfPackageDirectoryIsInClassOrSourcePath ();
S_typeModifiers *cccFunApplication ();
void javaHumanizeLinkName ();
S_symbol *cfAddCastsToModule ();
void addSuperClassOrInterface ();
int javaCreateClassFileItem ();
void addSuperClassOrInterfaceByName ();
void fsRecMapOnFiles ();
int fsIsMember ();
int zipIndexArchive ();
int zipFindFile ();
void javaMapZipDirFile ();
void javaReadClassFile ();
int cyyparse ();
void makeCCompletions ();
int javaslyyparse ();
int javayyparse ();
void makeJavaCompletions ();
int cccyyparse ();
void makeCccCompletions ();
int yaccyyparse ();
void makeYaccCompletions ();
int cexpyyparse ();
void charBuffClose ();
int getCharBuf ();
void switchToZippedCharBuff ();
int skipNCharsInCharBuf ();
int getLexBuf ();
void gotOnLineCxRefs ();
void ppMemInit ();
void initAllInputs ();
void initInput ();
void addIncludeReference ();
void addThisFileDefineIncludeReference ();
void pushNewInclude ();
void popInclude ();
void copyDir ();
char *normalizeFileName ();
int addFileTabItem ();
void getOrCreateFileInfo ();
void setOpenFileInfo ();
void addMacroDefinedByOption ();
char *placeIdent ();
int yylex ();
int cachedInputPass ();
int cexpyylex ();
extern char *yytext;
void cccLexBackTrack ();
int cccylex ();
int cccGetLexPosition ();
extern int s_cccYylexBufi;
int cexpTranslateToken ();
int testFileModifTime ();
void initCaching ();
void recoverCachePoint ();
void recoverFromCache ();
void cacheInput ();
void cacheInclude ();
void poseCachePoint ();
void recoverCxMemory ();
void recoverCachePointZero ();
void recoverMemoriesAfterOverflow ();
void addSourcePathesCut();
void getXrefrcFileName( char *ttt );
void optionsVisualEdit();
int processInteractiveFlagOption(char **argv, int i);
char *getJavaHome();
char *getJdkClassPathFastly();
void getJavaClassAndSourcePath ();
int packageOnCommandLine ();
void getStandardOptions ();
char *expandSpecialFilePredefinedVariables_st ();
int readOptionFromFile ();
void readOptionFile ();
void readOptionPipe ();
void javaSetSourcePath ();
void getOptionsFromMessage ();
int changeRefNumOption ();
void initCwd ();
void reInitCwd ();
void initTokenNameTab ();
void initJavaTypePCTIConvertIniTab ();
void initTypeCharCodeTab ();
void initArchaicTypes ();
void initPreCreatedTypes ();
void initTypeModifiersTabs();
void initExtractStoragesNameTab();
void initTypesNamesTab();
int versionNumber ();
void genClassHierarchyItemLinks ();
void htmlGenNonVirtualGlobSymList ();
void htmlGenGlobRefsForVirtMethod ();
int htmlRefItemsOrderLess ();
int isThereSomethingPrintable ();
void htmlGenEmptyRefsFile();
void javaGetClassNameFromFileNum ();
void javaSlashifyDotName ();
void javaDotifyClassName ();
void javaDotifyFileName ();
int isAbsolutePath ();
char *htmlNormalizedPath ();
char *htmlGetLinkFileNameStatic ();
void recursivelyCreateFileDirIfNotExists ();
void concatPathes ();
void htmlPutChar ();
void htmlPrint ();
void htmlGenGlobalReferenceLists ();
void htmlAddJavaDocReference ();
void generateHtml ();
int addHtmlCutPath ();
void htmlGetDefinitionReferences();
void htmlAddFunctionSeparatorReference();
void actionsBeforeAfterExternalDefinition();
void extractActionOnBlockMarker();
void genInternalLabelReference ();
S_symbol * addContinueBreakLabelSymbol ();
void deleteContinueBreakLabelSymbol ();
void genContinueBreakReference ();
void genSwitchCaseFork ();
void genSafetyCheckFailAction();
S_symbol *jslTypeSpecifier1 ();
S_symbol *jslTypeSpecifier2 ();
void jslCompleteDeclarator ();
S_typeModifiers *jslPrependComposedType ();
S_typeModifiers *jslAppendComposedType ();
S_symbol *jslPrependDirectEnclosingInstanceArgument ();
S_symbol *jslMethodHeader ();
S_symbol *jslTypeNameDefinition ();
S_symbol *jslTypeSymbolDefinition ();
int jslClassifyAmbiguousTypeName ();
void jslAddNestedClassesToJslTypeTab ();
void jslAddSuperNestedClassesToJslTypeTab ();
void jslAddSuperClassOrInterfaceByName ();
void jslNewClassDefinitionBegin ();
void jslAddDefaultConstructor ();
void jslNewClassDefinitionEnd ();
void jslNewAnonClassDefinitionBegin ();
void jslAddSuperClassOrInterface ();
void jslAddMapedImportTypeName ();
void jslAddAllPackageClassesFromFileTab ();
extern S_jslStat *s_jsl;
void dirInputFile ();
void crOptionStr ();
void xrefSetenv ();
int mainHandleSetOption ();
void copyOptions ();
void resetPendingSymbolMenuData();
char *presetEditServerFileDependingStatics ();
void searchDefaultOptionsFile ();
void processOptions ();
void mainSetLanguage ();
void getAndProcessXrefrcOptions ();
char * getInputFile ();
void getPipedOptions ();
void mainCallEditServerInit ();
void mainCallEditServer ();
void mainCallXref ();
void mainXref ();
void writeRelativeProgress ();
void mainTaskEntryInitialisations ();
void mainOpenOutputFile ();
void mainCloseOutputFile ();
void editorInit ();
int statb ();
int editorMarkerLess ();
int editorMarkerLessOrEq ();
int editorMarkerGreater ();
int editorMarkerGreaterOrEq ();
int editorMarkerListLess ();
int editorRegionListLess ();
S_editorBuffer *editorOpenBufferNoFileLoad ();
S_editorBuffer *editorGetOpenedBuffer ();
S_editorBuffer *editorGetOpenedAndLoadedBuffer ();
S_editorBuffer *editorFindFile ();
S_editorBuffer *editorFindFileCreate ();
S_editorMarker *editorCrNewMarkerForPosition ();
S_editorMarkerList *editorReferencesToMarkers ();
S_reference *editorMarkersToReferences ();
void editorRenameBuffer ();
void editorReplaceString ();
void editorMoveBlock ();
void editorDumpBuffer ();
void editorDumpBuffers ();
void editorDumpMarker ();
void editorDumpMarkerList ();
void editorDumpRegionList ();
void editorQuasySaveModifiedBuffers ();
void editorLoadAllOpenedBufferFiles ();
S_editorMarker *editorCrNewMarker ();
S_editorMarker *editorDuplicateMarker ();
int editorCountLinesBetweenMarkers ();
int editorRunWithMarkerUntil ();
int editorMoveMarkerToNewline ();
int editorMoveMarkerToNonBlank ();
int editorMoveMarkerBeyondIdentifier ();
int editorMoveMarkerToNonBlankOrNewline ();
void editorRemoveBlanks ();
void editorDumpUndoList ();
void editorMoveMarkerToLineCol ();
void editorMarkersDifferences ();
void editorFreeMarker ();
void editorFreeMarkerListNotMarkers ();
void editorFreeMarkersAndRegionList ();
void editorFreeRegionListNotMarkers ();
void editorSortRegionsAndRemoveOverlaps ();
void editorSplitMarkersWithRespectToRegions ();
void editorRestrictMarkersToRegions ();
S_editorMarker *editorCrMarkerForBufferBegin ();
S_editorMarker *editorCrMarkerForBufferEnd ();
S_editorRegionList *editorWholeBufferRegion ();
void editorScheduleModifiedBuffersToUpdate ();
void editorFreeMarkersAndMarkerList ();
int editorMapOnNonexistantFiles ();
void editorCloseBufferIfClosable ();
void editorCloseAllBuffersIfClosable ();
void editorCloseAllBuffers ();
void editorTest ();
void refactoryAskForReallyContinueConfirmation ();
void refactoryDisplayResolutionDialog ();
void editorApplyUndos ();
void editorUndoUntil ();
void mainRefactory ();
extern char *s_debugSurveyPointer;
extern int s_fileAbortionEnabled;
extern int s_wildCharSearch;
extern int s_lastReturnedLexem;
extern S_position s_spp[SPP_MAX];
extern S_usageBits s_noUsage;
extern int s_progressFactor;
extern int s_progressOffset;
extern S_availableRefactoring s_availableRefactorings[500];
extern S_editorUndo *s_editorUndo;
extern z_stream s_defaultZStream;
extern time_t s_expTime;
extern int s_cxResizingBlocked;
extern S_counters s_count;
extern unsigned s_recFindCl;
extern FILE *errOut;
extern FILE *dumpOut;
extern char tmpBuff[TMP_BUFF_SIZE];
extern char s_olSymbolType[COMPLETION_STRING_SIZE];
extern char s_olSymbolClassType[COMPLETION_STRING_SIZE];
extern S_position s_paramPosition;
extern S_position s_paramBeginPosition;
extern S_position s_paramEndPosition;
extern S_position s_primaryStartPosition;
extern S_position s_staticPrefixStartPosition;
extern S_idIdent s_yyIdentBuf[YYBUFFERED_ID_INDEX];
extern int s_yyIdentBufi;
extern char *s_cppVarArgsName;
extern char s_defaultClassPath[];
extern S_idIdent s_javaAnonymousClassName;
extern S_idIdent s_javaConstructorName;
extern S_stringList *s_javaClassPaths;
extern char *s_javaSourcePaths;
extern S_idIdentList *s_javaDefaultPackageName;
extern S_idIdentList *s_javaLangName;
extern S_idIdentList *s_javaLangStringName;
extern S_idIdentList *s_javaLangCloneableName;
extern S_idIdentList *s_javaIoSerializableName;
extern S_idIdentList *s_javaLangClassName;
extern S_idIdentList *s_javaLangObjectName;
extern char *s_javaLangObjectLinkName;
extern S_symbol s_javaArrayObjectSymbol;
extern S_symbol *s_javaStringSymbol;
extern S_symbol *s_javaObjectSymbol;
extern S_symbol *s_javaCloneableSymbol;
extern S_symbol *s_javaIoSerializableSymbol;
extern S_typeModifiers s_javaStringModifier;
extern S_typeModifiers s_javaClassModifier;
extern S_typeModifiers s_javaObjectModifier;
extern S_caching s_cache;
extern FILE *cxOut;
extern FILE *ccOut;
extern int s_javaPreScanOnly;
extern S_currentlyParsedCl s_cp;
extern S_currentlyParsedCl s_cpInit;
extern S_currentlyParsedStatics s_cps;
extern S_currentlyParsedStatics s_cpsInit;
extern S_topBlock *s_topBlock;
extern S_symTab *s_symTab;
extern S_javaFqtTab s_javaFqtTab;
extern S_idTab s_fileTab;
extern S_typeModifiers s_defaultIntModifier;
extern S_symbol s_defaultIntDefinition;
extern S_typeModifiers s_defaultPackedTypeModifier;
extern S_typeModifiers s_defaultVoidModifier;
extern S_symbol s_defaultVoidDefinition;
extern S_typeModifiers s_errorModifier;
extern S_symbol s_errorSymbol;
extern struct stat s_noStat;
extern S_position s_noPos;
extern S_reference s_noRef;
extern uchar typeLongChange[MAX_TYPE];
extern uchar typeShortChange[MAX_TYPE];
extern uchar typeSignedChange[MAX_TYPE];
extern uchar typeUnsignedChange[MAX_TYPE];
extern S_typeModifiers *s_structRecordCompletionType;
extern S_typeModifiers *s_upLevelFunctionCompletionType;
extern S_exprTokenType s_forCompletionType;
extern S_typeModifiers *s_javaCompletionLastPrimary;
extern char *s_tokenName[];
extern int s_tokenLength[];
extern S_tokenNameIni s_tokenNameIniTab[];
extern S_tokenNameIni s_tokenNameIniTab2[];
extern S_tokenNameIni s_tokenNameIniTab3[];
extern int s_preCrTypesIniTab[];
extern int next;
extern char nextus[32];
extern S_typeModifiers * s_preCrTypesTab[MAX_TYPE];
extern S_typeModifiers * s_preCrPtr1TypesTab[MAX_TYPE];
extern S_typeModifiers * s_preCrPtr2TypesTab[MAX_TYPE];
extern char s_javaBaseTypeCharCodes[MAX_TYPE];
extern int s_javaCharCodeBaseTypes[127];
extern char s_javaTypePCTIConvert[MAX_TYPE];
extern S_javaTypePCTIConvertIni s_javaTypePCTIConvertIniTab[];
extern char s_javaPrimitiveWideningConversions[MAX_PCTIndex-1][MAX_PCTIndex-1];
extern S_typeCharCodeIni s_baseTypeCharCodesIniTab[];
extern S_typeModificationsInit s_typeModificationsInit[];
extern S_position s_olcxByPassPos;
extern S_position s_cxRefPos;
extern int s_cxRefFlag;
extern S_refTab s_cxrefTab;
extern FILE *fIn;
extern int s_input_file_number;
extern int s_olStringSecondProcessing;
extern int s_olOriginalFileNumber;
extern int s_olOriginalComFileNumber;
extern int s_noneFileIndex;
extern S_intStringTab s_typesNamesInitTab[];
extern char *s_extractStorageName[MAX_STORAGE];
extern S_intStringTab s_extractStoragesNamesInitTab[];
extern S_fileDesc cFile;
extern char *s_editCommunicationString;
extern time_t s_expiration;
extern S_memory *cxMemory;
extern char tmpMemory[SIZE_TMP_MEM];
extern char memory[SIZE_workMemory];
extern char tmpWorkMemory[SIZE_tmpWorkMemory];
extern int tmpWorkMemoryi;
extern char ppmMemory[SIZE_ppmMemory];
extern int ppmMemoryi;
extern char ftMemory[SIZE_ftMemory];
extern int ftMemoryi;
extern int olcxMemoryAllocatedBytes;
extern char s_cwd[MAX_FILE_NAME_SIZE];
extern char s_base[MAX_FILE_NAME_SIZE];
extern char s_file[MAX_FILE_NAME_SIZE];
extern char s_path[MAX_FILE_NAME_SIZE];
extern char s_name[MAX_FILE_NAME_SIZE];
extern char ppcTmpBuff[MAX_PPC_RECORD_SIZE];
extern jmp_buf cxmemOverflow;
extern jmp_buf s_memoryResize;
extern char *s_input_file_name;
extern time_t s_fileProcessStartTime;
extern int s_language;
extern int s_currCppPass;
extern int s_maximalCppPass;
extern S_completions s_completions;
extern S_userOlcx *s_olcxCurrentUser;
extern unsigned s_menuFilterOoBits[MAX_MENU_FILTER_LEVEL];
extern int s_refListFilters[MAX_REF_LIST_FILTER_LEVEL];
extern char s_olstring[MAX_FUN_NAME_SIZE];
extern int s_olstringFound;
extern int s_olstringServed;
extern int s_olstringUsage;
extern char *s_olstringInMbody;
extern int s_olMacro2PassFile;
extern char mbMemory[SIZE_mbMemory];
extern int mbMemoryi;
extern struct fileDesc inStack[INSTACK_SIZE];
extern int inStacki;
extern struct lexInput macStack[MACSTACK_SIZE];
extern int macStacki;
extern S_lexInput cInput;
extern int s_ifEvaluation;
extern S_options s_opt;
extern S_options s_ropt;
extern S_options s_cachedOptions;
extern int s_javaRequiredeAccessibilitiesTable[3 +1];
extern S_options s_initOpt;
extern S_javaStat *s_javaStat;
extern S_javaStat s_initJavaStat;
extern char *s_javaThisPackageName;
extern S_zipFileTabItem s_zipArchivTab[MAX_JAVA_ZIP_ARCHIVES];
